Index: /branches/UKMO/r6232_HZG_WAVE-coupling/NEMOGCM/NEMO/OPA_SRC/SBC/sbcflx.F90
===================================================================
--- /branches/UKMO/r6232_HZG_WAVE-coupling/NEMOGCM/NEMO/OPA_SRC/SBC/sbcflx.F90	(revision 8763)
+++ /branches/UKMO/r6232_HZG_WAVE-coupling/NEMOGCM/NEMO/OPA_SRC/SBC/sbcflx.F90	(revision 8764)
@@ -30,11 +30,10 @@
    PUBLIC sbc_flx       ! routine called by step.F90
 
-   INTEGER             ::   jpfld   = 6   ! maximum number of files to read 
-   INTEGER             ::   jp_utau       ! index of wind stress (i-component) file
-   INTEGER             ::   jp_vtau       ! index of wind stress (j-component) file
-   INTEGER             ::   jp_qtot       ! index of total (non solar+solar) heat file
-   INTEGER             ::   jp_qsr        ! index of solar heat file
-   INTEGER             ::   jp_emp        ! index of evaporation-precipation file
-   INTEGER             ::   jp_press      ! index of pressure for UKMO shelf fluxes
+   INTEGER , PARAMETER ::   jpfld   = 5   ! maximum number of files to read 
+   INTEGER , PARAMETER ::   jp_utau = 1   ! index of wind stress (i-component) file
+   INTEGER , PARAMETER ::   jp_vtau = 2   ! index of wind stress (j-component) file
+   INTEGER , PARAMETER ::   jp_qtot = 3   ! index of total (non solar+solar) heat file
+   INTEGER , PARAMETER ::   jp_qsr  = 4   ! index of solar heat file
+   INTEGER , PARAMETER ::   jp_emp  = 5   ! index of evaporation-precipation file
    TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf    ! structure of input fields (file informations, fields read)
    LOGICAL , PUBLIC    ::   ln_shelf_flx = .FALSE. ! UKMO SHELF specific flux flag
@@ -93,5 +92,4 @@
       CHARACTER(len=100) ::  cn_dir                               ! Root directory for location of flx files
       NAMELIST/namsbc_flx/ ln_shelf_flx, ln_rel_wind, rn_wfac     ! Put here to allow merging with another UKMO branch
-      LOGICAL  :: ln_readtau                                      ! Is it necessary to read tau from file?
       TYPE(FLD_N), DIMENSION(jpfld) ::   slf_i                    ! array of namelist information structures
       TYPE(FLD_N) ::   sn_utau, sn_vtau, sn_qtot, sn_qsr, sn_emp  ! informations about the fields to be read
@@ -99,21 +97,4 @@
       !!---------------------------------------------------------------------
       !
-      ln_readtau = .NOT. (ln_wave .AND. ln_tauw )
-
-      ! prepare the index of the fields that have to be read
-      jpfld = 0
-      IF( ln_readtau ) THEN
-         jp_utau = jpfld+1
-         jp_vtau = jpfld+2
-         jpfld = jpfld+2
-      ELSE
-         jp_utau = 0   ;  jp_vtau = 0
-      ENDIF
-      jp_qtot = jpfld+1
-      jp_qsr = jpfld+2
-      jp_emp = jpfld+3
-      jp_press = jpfld+4
-      jpfld = jpfld+4
-
       IF( kt == nit000 ) THEN                ! First call kt=nit000  
          ! set file information
@@ -141,7 +122,5 @@
          !
          !                                         ! store namelist information in an array
-         IF( ln_readtau ) THEN
          slf_i(jp_utau) = sn_utau   ;   slf_i(jp_vtau) = sn_vtau
-         ENDIF
          slf_i(jp_qtot) = sn_qtot   ;   slf_i(jp_qsr ) = sn_qsr 
          slf_i(jp_emp ) = sn_emp
@@ -167,5 +146,5 @@
 
          !!UKMO SHELF wind speed relative to surface currents - put here to allow merging with coupling branch
-         IF( ln_shelf_flx .AND. ln_readtau ) THEN
+         IF( ln_shelf_flx ) THEN
             CALL wrk_alloc( jpi,jpj, zwnd_i, zwnd_j )
 
@@ -199,5 +178,5 @@
          !                                                        ! add modification due to drag coefficient read from wave forcing
          !                                                        ! this code is inefficient but put here to allow merging with another UKMO branch
-         IF( ln_shelf_flx .AND. ln_readtau ) THEN
+         IF( ln_shelf_flx ) THEN
             IF( ln_cdgw .AND. nn_drag == jp_std ) THEN
                IF( cpl_wdrag ) THEN 
@@ -233,5 +212,4 @@
          !
          !                                                        ! module of wind stress and wind speed at T-point
-         IF( ln_readtau ) THEN
          zcoef = 1. / ( zrhoa * zcdrag )
 !CDIR NOVERRCHK
@@ -255,5 +233,4 @@
          taum(:,:) = taum(:,:) * tmask(:,:,1) ; wndm(:,:) = wndm(:,:) * tmask(:,:,1)
          CALL lbc_lnk( taum(:,:), 'T', 1. )   ;   CALL lbc_lnk( wndm(:,:), 'T', 1. )
-         ENDIF
 
          IF( nitend-nit000 <= 100 .AND. lwp ) THEN                ! control print (if less than 100 time-step asked)
@@ -271,5 +248,5 @@
          ENDIF
          !
-         IF( ln_shelf_flx .AND. ln_readtau ) THEN
+         IF( ln_shelf_flx ) THEN
             CALL wrk_dealloc( jpi,jpj, zwnd_i, zwnd_j )
          ENDIF